config/routes.rb
Rails.application.routes.draw do
  get 'users/index'
  get 'contacts/index'
  devise_for :users
  get 'home/index'
  root 'home#index'

  resources :contacts

  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/contact.rb
class Contact < ApplicationRecord
    belongs_to :user
    validates_presence_of :name, :number
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable
  has_many :contacts
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/contacts_controller.rb
class ContactsController < ApplicationController
    before_action :authenticate_user!
    before_action :set_contact, only: [:edit, :update, :show, :destroy]
    before_action :owner_contact, only: [:edit, :update, :show, :destroy]

  def index
    @contacts = current_user.contacts
  end

  def new
    @contact = Contact.new
  end

  def create
    @contact = current_user.contacts.new(params_contact)
    if @contact.save
      redirect_to contacts_path, notice: "O contato (#{@contact.name} #{@contact.last_name}) foi salvo com sucesso!"
    else
      render :new
    end
  end

  def edit
  end

  def update
    if @contact.update(params_contact)
      redirect_to contacts_path, notice: "O contato (#{@contact.name} #{@contact.last_name}) foi alterado com sucesso!"
    else
      render :edit
    end
  end

  def destroy
    if @contact.destroy
      redirect_to contacts_path, notice: "O contato (#{@contact.name} #{@contact.last_name}) foi apagado com sucesso!"
    else
      render :destroy
    end
  end

  private

    def params_contact
      params.require(:contact).permit(:name, :last_name, :number, :user_id)
    end

    def set_contact
      @contact = Contact.find(params[:id])
    end

    def owner_contact
      unless current_user == @contact.user
        redirect_to contacts_path
      end
    end
end

app/controllers/home_controller.rb
class HomeController < ApplicationController
  def index
  end
end

app/controllers/users_controller.rb
class UsersController < ApplicationController
  before_action :authenticate_user!
    before_action :set_users, only: [:edit, :update, :show, :destroy]

  def index
    @user = User.all
  end

  def new
    @user = User.new
  end

  def create
    @user = current_user.new(params_contact)
    if @user.save
      redirect_to user_path, notice: "O usuário (#{@user.name} #{@user.email}) foi salvo com sucesso!"
    else
      render :new
    end
  end

  def edit
  end

  def update
    if @user.update(params_user)
      redirect_to user_path, notice: "O usuário (#{@user.name} #{@user.email}) foi alterado com sucesso!"
    else
      render :edit
    end
  end

  def destroy
    if @user.destroy
      redirect_to user_path, notice: "O usuário (#{@user.name} #{@user.email}) foi apagado com sucesso!"
    else
      render :destroy
    end
  end

  private

    def params_user
      params.require(:user).permit(:name, :email)
    end

    def set_user
      @user = User.find(params[:id])
    end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/contacts_helper.rb
module ContactsHelper
end

app/helpers/home_helper.rb
module HomeHelper
end

app/helpers/users_helper.rb
module UsersHelper
end

app/views/contacts/edit.html.erb
<%= render partial: "contacts/shared/form",
           locals: {action: "Edit Contact"} %>

app/views/contacts/index.html.erb
<h1>Contact List</h1>

<div style="margin: 0 3%">
	<table style="width: 90%;" cellspacing="0" cellpadding="0">
		<tbody>
            <th style="width: 5%;">Id</th>
            <th>Nome</th>
            <th>Telefone</th>
            <th colspan="2"><%= link_to "Novo Contato", new_contact_path%></th>
		    <tr><td style="height: 5px;" colspan="6"></td></tr>
		    <tr><td style="border-top: solid 1px #000000; height: 5px;" colspan="5"></td></tr>
            <% @contacts.each do |contact| %>
                <tr>
                    <td>
                        <%= contact.id %>
                    </td>
                    <td>
                        <%= contact.name %>
                        <%= contact.last_name %>
                    </td>
                    <td><%= contact.number %></td>
                    <td><%= link_to "Edit", edit_contact_path(contact) %></td>
                    <td>
                    <% if current_user.id == contact.user.id %>
                        <%= link_to "Remover", contact_path(contact), method: :delete, data: {confirm: "Você deseja realmente remover o contato (#{contact.name} #{contact.last_name})?"} %></td>
                    <% end %>
                </tr>
            <% end %>
        </tbody>
    </table>
</div>

app/views/contacts/new.html.erb
<%= render partial: "contacts/shared/form",
           locals: {action: "New Contact"} %>

app/views/contacts/shared/_form.html.erb
<h1><%= action %></h1>

<% if @contact.errors.any? %>
  <ul>
    <% @contact.errors.full_messages.each do |message| %>
      <li><%= message %></li>
    <% end %>
  </ul>
<% end %>

<%= form_for(@contact) do |f| %>
  <div class="field">
    <%= f.label :name %>
    <%= f.text_field :name %>
  </div>

  <div class="field">
    <%= f.label :last_name %>
    <%= f.text_field :last_name %>
  </div>

  <div class="field">
    <%= f.label :number %>
    <%= f.text_field :number %>
  </div>

  <div class="actions">
    <%= f.submit "Salvar" %>
  </div>
<% end %>

app/views/home/index.html.erb
<h1>Home</h1>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>PhoneBook</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>

    <div class="sidebar_top">

      <div>

        <tr>
          <span class="logo_cabecalho"></span>
          <%= link_to "Home", new_user_session_path %>
          <%= link_to "Contatos", contacts_index_path %>  
          <%= link_to "Usuários", users_index_path %>
          <% if current_user %>
            Bem vindo, <%= current_user.name%>(<%= current_user.email%>)
            <%= link_to "Sair", destroy_user_session_path, method: :delete %>
          <% end %>

      </div>
      
      <% if notice %>
        <%= notice %>
      <% end %>

    </div>

    <div class="corpo">
      <%= yield %>
    </div>
    
    <div class="sidebar_bottom"></div>

  </body>
</html>

app/views/users/New.html.erb
<%= form_for(@user) do |f| %>
  <div class="field">
    <%= f.label :name %>
    <%= f.text_field :name %>
  </div>

  <div class="field">
    <%= f.label :email %>
    <%= f.text_field :email %>
  </div>

  <div class="field">
    <%= f.label :number %>
    <%= f.text_field :number %>
  </div>

  <div class="actions">
    <%= f.submit "Salvar" %>
  </div>
<% end %>

app/views/users/index.html.erb
<h1>User List</h1>

<div style="margin: 0 3%">
	<table style="width: 90%;" cellspacing="0" cellpadding="0">
		<tbody>
            <th>Id</th>
            <th>Usuário</th>
            <th>E-mail</th>
            <th>Contatos</th>
            <th></th>
            <th></th>
		    <tr><td style="height: 5px;" colspan="6"></td></tr>
		    <tr><td style="border-top: solid 1px #000000; height: 5px;" colspan="6"></td></tr>
            <% @user.each do |user| %>
                <tr>
                    <td>
                        <%= user.id %>
                    </td>
                    <td>
                        <%= user.name %>
                    </td>
                    <td>
                        <%= user.email %>
                    </td>
                    <td>
                        <%= user.contacts.map{|contact| contact.name}.to_sentence %>
                    </td>
                    <td>Editar</td>
                    <td>Remover</td>
                </tr>
            <% end %>
        </tbody>
    </table>
</div>

app/views/users/shared/_error_messages.html.erb
<% if resource.errors.any? %>
  <div id="error_explanation">
    <h2>
      <%= I18n.t("errors.messages.not_saved",
                 count: resource.errors.count,
                 resource: resource.class.model_name.human.downcase)
       %>
    </h2>
    <ul>
      <% resource.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
    </ul>
  </div>
<% end %>

app/views/users/shared/_links.html.erb
<%- if controller_name != 'sessions' %>
  <%= link_to "Log in", new_session_path(resource_name) %><br />
<% end %>

<%- if devise_mapping.registerable? && controller_name != 'registrations' %>
  <%= link_to "novo", new_registration_path(resource_name) %><br />
<% end %>

<%- if devise_mapping.recoverable? && controller_name != 'passwords' && controller_name != 'registrations' %>
  <%= link_to "Forgot your password?", new_password_path(resource_name) %><br />
<% end %>

<%- if devise_mapping.confirmable? && controller_name != 'confirmations' %>
  <%= link_to "Didn't receive confirmation instructions?", new_confirmation_path(resource_name) %><br />
<% end %>

<%- if devise_mapping.lockable? && resource_class.unlock_strategy_enabled?(:email) && controller_name != 'unlocks' %>
  <%= link_to "Didn't receive unlock instructions?", new_unlock_path(resource_name) %><br />
<% end %>

<%- if devise_mapping.omniauthable? %>
  <%- resource_class.omniauth_providers.each do |provider| %>
    <%= link_to "Sign in with #{OmniAuth::Utils.camelize(provider)}", omniauth_authorize_path(resource_name, provider), method: :post %><br />
  <% end %>
<% end %>